Bug 227944 - www/apache24 error in Makefile
Summary: www/apache24 error in Makefile
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: freebsd-apache (Nobody)
URL: https://reviews.freebsd.org/D16294
Keywords:
Depends on: 229802
Blocks:
  Show dependency treegraph
 
Reported: 2018-05-03 05:25 UTC by gja822
Modified: 2018-12-27 10:07 UTC (History)
2 users (show)

See Also:
bugzilla: maintainer-feedback? (apache)


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description gja822 2018-05-03 05:25:53 UTC
Trying to make www/apache24 on FreeBSD 10.4-STABLE #0 r333087 amd64 gives the error:

# make
make: "/usr/ports/www/apache24/Makefile" line 189: Malformed conditional (${OPSYS} == FreeBSD && ${OSVERSION} < 1100085 && ${PORT_OPTIONS:MHTTP2} && ${OPENSSLBASE} == /usr)
make: Fatal errors encountered -- cannot continue
make: stopped in /usr/ports/www/apache24
Comment 1 Bernard Spil freebsd_committer 2018-05-03 09:11:14 UTC
Hi,

Can you please report the output of the following commands?
> make -VOPSYS
> make -VOSVERSION
> make -VOPENSSLBASE
> make -VPORTOPTIONS
Comment 2 Marco Beishuizen 2018-05-03 16:29:13 UTC
I got this error on FreeBSD yokozuna 11.1-STABLE FreeBSD 11.1-STABLE #0 r328478: Sat Jan 27 22:31:28 CET 2018     root@yokozuna:/usr/obj/usr/src/sys/YOKOZUNA  amd64:

...
--- mod_sed.la ---
eval: /usr/local/bin/nm: not found
/usr/bin/ld:.libs/mod_sed.so-ver:2: syntax error in VERSION script
cc: error: linker command failed with exit code 1 (use -v to see invocation)
*** [mod_sed.la] Error code 1

make[6]: stopped in /usr/ports/www/apache24/work/httpd-2.4.33/modules/filters
1 error
...

Maybe this is related or the same?
Comment 3 gja822 2018-05-03 16:59:02 UTC
(In reply to Bernard Spil from comment #1)

/usr/ports# make -VOPSYS
FreeBSD
/usr/ports# make -VOSVERSION
1004501
/usr/ports# make -VOPENSSLBASE

/usr/ports# make -VPORTOPTIONS

/usr/ports#


(Of course, the same commands from www/apache24 directory will give the error mentioned in the bug.)

Additionally, I have this line in /etc/make.conf
DEFAULT_VERSIONS= bdb=6 lua=5.3 mysql=5.6 ssl=base gcc=7
Comment 4 gja822 2018-05-03 17:00:45 UTC
(In reply to Marco Beishuizen from comment #2)

Can't be sure, but I suppose, these are different bugs.
Comment 5 Marco Beishuizen 2018-05-03 17:14:25 UTC
Ok I'll create a separate PR for this.
Comment 6 Bernard Spil freebsd_committer 2018-05-03 18:26:22 UTC
(In reply to gja822 from comment #3)
Naturally you run into the error...
Can you comment out that block and run the make -V's again, there must be something unset that makes it fail.
Your Mk dir fully up-to-date I assume?

In my tree I have no issues whether HTTP2 is on/off or I set DEFAULT_VERSIONS+= ssl=base
Comment 7 gja822 2018-05-04 02:34:36 UTC
(In reply to Bernard Spil from comment #6)

Yes, just "portsnap fetch update", of course.

After commenting the block the output of "make -V*"s is absolutely the same.

Options that are ON are: ASIS, DATA, ENV, HEADERS, HTTP2, IDENT, INCLUDE, PROXY, VERSION, WATCHDOG, PROXY_BALANCER, PROXY_HTTP2, PROXY_HCHECK, PROXY_HTTP, PROXY_UWSGI, MPM_PREFORK
Comment 8 gja822 2018-05-04 02:51:20 UTC
The output of

${ECHO_CMD} "[[[ !${OPSYS}!  !${OSVERSION}!  !${PORT_OPTIONS:MHTTP2}! !${OPENSSLBASE}! ]]]"

is

[[[ !FreeBSD!  !1004501!  !HTTP2! !! ]]]

from within the Makefile (I put it in post-extract section).

May be, the empty OPENSSLBASE confuses it?
Comment 9 Bernard Spil freebsd_committer 2018-05-04 08:56:47 UTC
(In reply to gja822 from comment #8)
There's surely an issue with your build system and/or ports tree. I guess that output of make -VUSES contains ssl? USES=ssl triggers OPENSSLBASE to be set.
Comment 10 gja822 2018-05-04 10:16:36 UTC
(In reply to Bernard Spil from comment #9)

/usr/ports/www/apache24# make -VUSES
apache:server,2.4 autoreconf cpe iconv libtool perl5 tar:bzip2
Comment 11 Bernard Spil freebsd_committer 2018-05-07 10:10:36 UTC
(In reply to gja822 from comment #7)
(In reply to gja822 from comment #10)

Figured it out. You're building with both SSL and MD switched off. The check is not correct, but I doubt that your config would result in what you want. You want HTTP2 without SSL?
Comment 12 gja822 2018-05-07 11:36:43 UTC
(In reply to Bernard Spil from comment #11)
Thank you for pointing me out this deficiency of my configuration.
Although I do not use www/apache24 directly, it was a dependency of some GNOME ages ago.
Comment 13 Bernard Spil freebsd_committer 2018-05-13 08:51:58 UTC
See also https://reviews.freebsd.org/D15411
Comment 14 commit-hook freebsd_committer 2018-07-20 14:27:27 UTC
A commit references this bug:

Author: joneum
Date: Fri Jul 20 14:26:45 UTC 2018
New revision: 475018
URL: https://svnweb.freebsd.org/changeset/ports/475018

Log:
  www/apache24: Update to 2.4.34

   - fixes vulns in mod_http2 and mod_md
   - include SSL_* options in alphabetic ordering
   - Remove unneeded SSL_CFLAGS and _LDFLAGS
   - Remove WITH_HTTP_PORT and WITH_SSL_PORT
   - Remove trailing whitespace
   - Fix build with HTTP2 but without SSL [1]

  PR:		229802, 227944 [1]
  With hat:	apache
  Approved by:	brnrd (apache)
  MFH:		2018Q3
  Security:	8b1a50ab-8a8e-11e8-add2-b499baebfeaf
  Differential Revision:	https://reviews.freebsd.org/D16294

Changes:
  head/www/apache24/Makefile
  head/www/apache24/distinfo
  head/www/apache24/files/patch-modules_md_md__crypt.c
  head/www/apache24/pkg-descr
  head/www/apache24/pkg-message
  head/www/apache24/pkg-plist
Comment 15 commit-hook freebsd_committer 2018-07-20 14:34:40 UTC
A commit references this bug:

Author: joneum
Date: Fri Jul 20 14:34:24 UTC 2018
New revision: 475020
URL: https://svnweb.freebsd.org/changeset/ports/475020

Log:
  MFH: r475018

  www/apache24: Update to 2.4.34

   - fixes vulns in mod_http2 and mod_md
   - include SSL_* options in alphabetic ordering
   - Remove unneeded SSL_CFLAGS and _LDFLAGS
   - Remove WITH_HTTP_PORT and WITH_SSL_PORT
   - Remove trailing whitespace
   - Fix build with HTTP2 but without SSL [1]

  PR:		229802, 227944 [1]
  With hat:	apache
  Approved by:	brnrd (apache)
  Security:	8b1a50ab-8a8e-11e8-add2-b499baebfeaf
  Differential Revision:	https://reviews.freebsd.org/D16294

  Approved by:	ports-secteam (miwi)

Changes:
_U  branches/2018Q3/
  branches/2018Q3/www/apache24/Makefile
  branches/2018Q3/www/apache24/distinfo
  branches/2018Q3/www/apache24/files/patch-modules_md_md__crypt.c
  branches/2018Q3/www/apache24/pkg-descr
  branches/2018Q3/www/apache24/pkg-message
  branches/2018Q3/www/apache24/pkg-plist